config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resources :friends
  # get 'home/index'

  # root 'home#index'
  root 'friends#index'

  get 'home/about'
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/friend.rb
class Friend < ApplicationRecord
  belongs_to :user
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  has_many :friends
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/friends_controller.rb
class FriendsController < ApplicationController
  before_action :set_friend, only: %i[show edit update destroy]
  before_action :authenticate_user!, except: %i[index show]
  before_action :correct_user, only: %i[edit update destroy]

  # GET /friends or /friends.json
  def index
    @friends = Friend.all
  end

  # GET /friends/1 or /friends/1.json
  def show
  end

  # GET /friends/new
  def new
    # @friend = Friend.new
    @friend = current_user.friends.build
  end

  # GET /friends/1/edit
  def edit
  end

  # POST /friends or /friends.json
  def create
    # @friend = Friend.new(friend_params)
    @friend = current_user.friends.build(friend_params)

    respond_to do |format|
      if @friend.save
        format.html { redirect_to friend_url(@friend), notice: "Friend was successfully created." }
        format.json { render :show, status: :created, location: @friend }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @friend.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /friends/1 or /friends/1.json
  def update
    respond_to do |format|
      if @friend.update(friend_params)
        format.html { redirect_to friend_url(@friend), notice: "Friend was successfully updated." }
        format.json { render :show, status: :ok, location: @friend }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @friend.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /friends/1 or /friends/1.json
  def destroy
    @friend.destroy

    respond_to do |format|
      format.html { redirect_to friends_url, notice: "Friend was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  def correct_user
    @friend = current_user.friends.find_by(id: params[:id])

    redirect_to friends_path, notice:'Not Authorized to Edit this Friend' if @friend.nil?
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_friend
      @friend = Friend.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def friend_params
      params.require(:friend).permit(:first_name, :last_name, :email, :phone, :twitter, :user_id)
    end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end

  def about
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/friends_helper.rb
module FriendsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/views/friends/_form.html.erb
<%= form_with(model: friend) do |form| %>
  <% if friend.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(friend.errors.count, "error") %> prohibited this friend from being saved:</h2>

      <ul>
        <% friend.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field form-group">
    <%# <%= form.label :first_name, style: "display: block" %>
    <%= form.text_field :first_name, class:"form-control", placeholder:"First Name" %>
  </div>

  <br/>
  <div class="field form-group">
    <%= form.text_field :last_name, class:"form-control", placeholder:"Last Name" %>
  </div>

  <br/>
  <div class="field form-group">
    <%= form.text_field :email, class:"form-control", placeholder:"Email" %>
  </div>

  <br/>
  <div class="field form-group">
    <%= form.text_field :phone, class:"form-control", placeholder:"Phone" %>
  </div>

  <br/>
  <div class="field form-group">
    <%= form.text_field :twitter, class:"form-control", placeholder:"Twitter" %>
  </div>

  <br/>
  <div class="field form-group">
    <%= form.number_field :user_id, id: :friend_user_id, class:"form-control", value:current_user.id, type: :hidden %>
  </div>
  
  <br/>
  <div class="action">
    <%= form.submit class:'btn btn-secondary' %>
  </div>
<% end %>

app/views/friends/_friend.html.erb
<div id="<%= dom_id friend %>">
  <p>
    <strong>First name:</strong>
    <%= friend.first_name %>
  </p>

  <p>
    <strong>Last name:</strong>
    <%= friend.last_name %>
  </p>

  <p>
    <strong>Email:</strong>
    <%= friend.email %>
  </p>

  <p>
    <strong>Phone:</strong>
    <%= friend.phone %>
  </p>

  <p>
    <strong>Twitter:</strong>
    <%= friend.twitter %>
  </p>

</div>

app/views/friends/edit.html.erb
<h1>Editing friend</h1>
<br/>

<%= render "form", friend: @friend %>

<br>

<div>
  <%= link_to "Show", @friend, class:'btn btn-secondary' %>
  <%= link_to "Back", friends_path, class:'btn btn-dark' %>
</div>

app/views/friends/index.html.erb
<% if user_signed_in? %>
  <br/>
  <table class="table table-striped table-bordered table-hover">
    <thead class="table-dark">
      <tr>
        <th scope="col">Name</th>
        <th scope="col">Email</th>
        <th scope="col">Phone</th>
        <th scope="col">Twitter</th>
        <th scope="col" colspan="2">Action</th>
      </tr>
    </thead>
    <tbody id="friends">
      <% @friends.each do |friend| %>
        <% if friend.user == current_user %>
          <tr>
            <td>
              <%= link_to friend.first_name + ' ' + friend.last_name, friend %>
            </td>
            <td><%= friend.email %></td>
            <td><%= friend.phone %></td>
            <td><%= friend.twitter %></td>
            <td>
              <%= link_to "Edit", edit_friend_path(friend), class:'btn btn-sm btn-outline-secondary' %>
            </td>
            <td>
              <%= button_to "Delete", friend_path(friend), method: :delete, data: {confirm: "Are you sure?"}, class:"btn btn-sm btn-outline-danger" %>
            </td>
          </tr>
        <% end %>
      <% end %>
    </tbody>
  </table>

  <%= link_to "New friend", new_friend_path, class:'btn btn-outline-secondary' %>
<% else %>
  <h1>Made with Rails</h1>
  <p>Sign in or sign up to manipulate your list of friends.</p>
<% end %>

app/views/friends/new.html.erb
<h1>New friend</h1>
<br/>

<%= render "form", friend: @friend %>

<br>

<div>
  <%= link_to "Back", friends_path, class:'btn btn-dark' %>
</div>

app/views/friends/show.html.erb
<div class="p-5 mb-4 bg-light rounded-3">
  <div class="container-fluid py-5">
    <h1 class="display-5 fw-bold"><%= @friend.first_name %> <%= @friend.last_name %></h1>
    <p class="col-md-8 fs-4">
      <%= @friend.email %> |
      <%= @friend.phone %> |
      <%= @friend.twitter %>
    </p>
    <br/>
    <div>
      <%= link_to "Edit", edit_friend_path(@friend), class:'btn btn-secondary' %>
      <%= link_to "Back", friends_path, class:'btn btn-dark' %>
      
      <%# <%= button_to "Delete", @friend, method: :delete, class:'btn btn-danger' %>
    </div>
  </div>
</div>

app/views/home/_header.html.erb
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
  <div class="container-fluid">
    <%= link_to "Friends App", root_path, class:"navbar-brand" %>
    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav me-auto mb-2 mb-lg-0">
        <li class="nav-item">
          <%= link_to "About", home_about_path, class:"nav-link btn" %>
        </li>
      </ul>
      <ul class="navbar-nav d-flex">
        <% if user_signed_in? %>
          <li class="nav-item">
            <%= link_to "Add Friend", new_friend_path, class:"nav-link btn" %>
          </li>
          <li class="nav-item">
            <%= button_to "Sign Out", destroy_user_session_path, method: :delete, class:"nav-link btn" %>
          </li>
          <li class="nav-item">
            <%= link_to "Edit Profile", edit_user_registration_path, class:"nav-link btn" %>
          </li>
        <% else %>
          <li class="nav-item">
            <%= link_to "Sign Up", new_user_registration_path, class:"nav-link btn" %>
          </li>
          <li class="nav-item">
            <%= link_to "Sign In", new_user_session_path, class:"nav-link btn" %>
          </li>
        <% end %>
      </ul>
      <%# <form class="d-flex">
        <input class="form-control me-2" type="search" placeholder="Search" aria-label="Search">
        <button class="btn btn-outline-success" type="submit">Search</button>
      </form> %>
    </div>
  </div>
</nav>
<br/>

app/views/home/about.html.erb
<h1>About Apps</h1>
<p>This is a Friends Listing Apps. Sign in or sign up to manipulate your list of friends.</p>

app/views/home/index.html.erb
<h1>Home#index Hello Rails</h1>
<p>Find me in app/views/home/index.html.erb</p>

app/views/layouts/_alerts.html.erb
<div class="alert alert-warning alert-dismissible fade show" role="alert">
  <%= notice %>
  <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
</div>

app/views/layouts/application.html.erb
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">

    <title>Friends App</title>

    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
  </head>
  <body>
    <%= render "home/header" %>
    <div class="container">
      <% if notice %>
        <br/>
        <%= render "layouts/alerts" %>
      <% end %>

      <%= yield %>
    </div>
    
    <!-- Optional JavaScript; choose one of the two! -->

    <!-- Option 1: Bootstrap Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>

    <!-- Option 2: Separate Popper and Bootstrap JS -->
    <!--
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.10.2/dist/umd/popper.min.js" integrity="sha384-7+zCNj/IqJ95wo16oMtfsKbZ9ccEh31eOz1HGyDuCQ6wgnyJNSYdrPa03rtR1zdB" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.min.js" integrity="sha384-QJHtvGhmr9XOIpI6YVutG+2QOK9T+ZnN4kzFN1RtK3zEFEIsxhlmWl5/YESvpZ13" crossorigin="anonymous"></script>
    -->
  </body>
</html>